#include "jacobi.h"
#include <stdio.h>

void jacobistep(double **psinew, double **psi, int m, int n){
    for(int i=1;i<=m;i++){
        for(int j=1;j<=n;j++){
            psinew[i][j]=0.25*(psi[i-1][j]+psi[i+1][j]+psi[i][j-1]+psi[i][j+1]);
        }
    }
}

void jacobistepvort(double **zetnew, double **psinew, double **zet, double** psi, int m, int n, double re){

    for(int i=1;i<=m;i++){
        for(int j=1;j<=n;j++){
            psinew[i][j]=0.25*(psi[i-1][j]+psi[i+1][j]+psi[i][j-1]+psi[i][j+1]-zet[i][j]);
        }
    }

    for(int i=1;i<=m;i++){
        for(int j=1;j<=n;j++){
            zetnew[i][j] =
             0.25*(zet[i-1][j]+zet[i+1][j]+zet[i][j-1]+zet[i][j+1])
             - re/16. * (
                 (psi[i][j+1]-psi[i][j-1])*(zet[i+1][j]-zet[i-1][j]) - (psi[i+1][j]-psi[i-1][j])*(zet[i][j+1]-zet[i][j-1])
             );
        }
    }



}

double deltasq(double **newarr, double **oldarr, int m, int n){
    double dsq=0.;
    double tmp;

    for(int i=1;i<=m;i++){
        for(int j=1;j<=n;j++){
            tmp = newarr[i][j]-oldarr[i][j];
            dsq += tmp*tmp;
        }
    }

    return dsq;
}
